
//------------------------------------------------------------------------------
/** @file    	ux_gui.c
    @brief   	GUI ó ̺귯 
    @author  	â bmfrog2@gmail.com
    @date 		2009 1 17
	@license 	GPLv2
*///----------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include <linux/input.h>
#include <linux/limits.h>				// PATH_MAX 
#include <linux/kdev_t.h>				// MKDEV

#include <sys/poll.h>
#include <sys/types.h>					// dev_t
#include <sys/stat.h>
#include <fcntl.h>

#include <gx.h>
#include <gxbmp.h>

#include <ex.h>
#include <ix.h>


#define MAX_TOUCH  4

//------------------------------------------------------------------------------
/** @brief	GUI ó ʿ ̺귯 ʱȭ Ѵ.    
    @param  exit_flag : ʱȭ н α׷    , 1 ̸ α׷  
    @return   
    @remark    
*///----------------------------------------------------------------------------
int ux_gui_lib_init( int exit_flag )
{
	FILE    *fp;
	int 	index;
	
	ix_cal_touch_info_t  touch_info[MAX_TOUCH] = 
	{
		// tx,     ty,    sx,   sy
		{ 	162, 		805, 		80, 	80	},
		{ 	832, 		805, 		560, 	80	},
		{ 	162, 		223, 		80, 	400	},
		{ 	832, 		223, 		560, 	400	},
	};
	
	char 	toutch_adjust_filename[128] = "/etc/exlib_tc.cfg";
	

   	if ( gx_init( "/dev/fb")) 							//  ۸ ̿Ͽ gxLib ʱȭ
   	{
   		gx_print_error("\n");                            
		goto end_label;
   	}
   	
	if( ex_init( EX_WAIT_TIME_DEFAULT ) )				// ex lib ʱȭ Ѵ.					
	{
		ex_print_error("\n");
		goto end_label;
	}

	if( ix_init() )										// ix lib ʱȭѴ.
	{
		ix_print_error("\n");
		goto end_label;
	}
	
	if(ix_auto_scan_open(IX_TMP_PATH_DEFAULT))			// Է ̹ ڵ˻  openó
	{
		ix_print_error("\n");
		goto end_label;
	}
	
	// Ͽ ġ ͸ д´.
	fp = fopen( toutch_adjust_filename, "r" );
	if( fp != NULL )
	{
		for( index = 0; index < MAX_TOUCH; index++ )
		{
			fscanf( fp, "%d,%d,%d,%d\n", &touch_info[index].sx, &touch_info[index].sy,&touch_info[index].tx, &touch_info[index].ty );
		}	
		fclose( fp );
	}
	
	// ġ  ͸ ִ´.
	for( index = 0; index < MAX_TOUCH; index++ )
	{
		ix_set_cal_touch_info( index , touch_info[index] );
	}
	ix_adjust_touch();
	
	return 0;
	
end_label:
	if( exit_flag ) exit(0);
	return -1;
}


#define MAX_COLOR_ITEMS             128
#define MAX_MAP_AREA                1024
#define MAP_AREA_COLOR               0
#define MAP_AREA_LEFT                1
#define MAP_AREA_TOP                 2
#define MAP_AREA_RIGHT               3
#define MAP_AREA_BOTTOM              4
#define MAP_AREA_TYPE              	 5
#define MAP_AREA_LAST             	 6

#define MAP_AREA_TYPE_NONE           0
#define MAP_AREA_TYPE_BUTTON         1

static color_t 	map_colors[MAX_COLOR_ITEMS];
static int 		map_colors_count = 0;

static int 		map_areas[MAX_MAP_AREA][MAP_AREA_LAST];
static int 		map_areas_count = 0;

static bmp_t   	*map_bmp_front 	= NULL;
static bmp_t   	*map_bmp_back 	= NULL;
static bmp_t   	*map_bmp_mask 	= NULL;

static dc_t		*map_dc         = NULL;
static int 		map_last_x     = 0;
static int 		map_last_y     = 0;


//------------------------------------------------------------------------------
/** @brief	 ׸ о ´.     
    @param 	fileaname : Ʈ ϸ   
    @return	 0  
    @return	 -1  
    @remark   
*///----------------------------------------------------------------------------
int 	ux_gui_screen_map_load_front_bitmap( char *filename )
{
	if( map_bmp_front != NULL ) gx_bmp_close( map_bmp_front );
	map_bmp_front = gx_bmp_open( filename );
	if( map_bmp_front == NULL ) return -1;
	return 0;	
}

//--------------------------------------------------------------
//  :  ׸ о ´. 
// Ű : fileaname : Ʈ ϸ
// ȯ :  0 ,  -1
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int 	ux_gui_screen_map_load_back_bitmap( char *filename )
{
	if( map_bmp_back != NULL ) gx_bmp_close( map_bmp_back );
	map_bmp_back = gx_bmp_open( filename );
	if( map_bmp_back == NULL ) return -1;
	return 0;	
}

//--------------------------------------------------------------
//  : ũ ׸ о ´. 
// Ű : fileaname : Ʈ ϸ
// ȯ :  0 ,  -1
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int 	ux_gui_screen_map_load_mask_bitmap( char *filename )
{
	if( map_bmp_mask != NULL ) gx_bmp_close( map_bmp_mask );
	map_bmp_mask = gx_bmp_open( filename );
	if( map_bmp_mask == NULL ) return -1;
	return 0;	
}

//--------------------------------------------------------------
//  : GUI ũ  ó ϴ  о ʱȭ Ѵ. 
// Ű : exit_flag ʱȭ н α׷   
//        1 ̸ α׷  
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_load( char *filename )
{
	FILE *fp;
	char readbuff[256];
	char *str;
	int  ret;
	int  index, r,g,b;
	int  left, top,right,bottom;
	
	memset( map_colors, 0, sizeof( map_colors ) );
	map_colors_count = 0;

	ret = 0;
	fp = fopen( filename,"r" );
	if( fp == NULL ) return -1;
		
	printf( "OK GOOD LOAD MAP FILE [%s]\n", filename );	
	while( !feof( fp ) )
	{
		memset( readbuff,0,sizeof( readbuff ) );
		fgets( readbuff, sizeof( readbuff ) -1, fp );
		str = readbuff;
		while( *str )
		{
			if( *str == 0x0A || *str == 0x0D ) *str = 0;
			str++;
		}
		
		if( readbuff[0] == 'E' && readbuff[1] == 'D' ) break;		//    ̸ ó 
		if( readbuff[0] == 'R' && readbuff[1] == 'M' ) continue;	// remark ̸  
			
		printf( "[%s]\n", readbuff );								// ׷ ǥ 
		
		// ׸  б û̸ ̿  ó 
		if( readbuff[0] == 'B' )
		{
			switch( readbuff[1] )
			{
			case 'F' : ret = ux_gui_screen_map_load_front_bitmap( &readbuff[3] ); break;
			case 'B' : ret = ux_gui_screen_map_load_back_bitmap	( &readbuff[3] ); break;
			case 'M' : ret = ux_gui_screen_map_load_mask_bitmap	( &readbuff[3] ); break;		
			}
			
			if( ret < 0 ) return ret;
			continue;
		}	

		//   ó 
		if( readbuff[0] == 'C' && readbuff[1] == 'M' ) 
		{
			sscanf( &readbuff[3], "%d,%d,%d,%d", &index, &r,&g,&b );
			if( index < MAX_COLOR_ITEMS )
			{
				if( map_colors_count < ( index + 1 ) ) map_colors_count = index + 1;
	    		map_colors[ index ].red 	= r;
	    		map_colors[ index ].green 	= g;
	    		map_colors[ index ].blue 	= b;
			}

			continue;
		}
		//   ó 
		if( readbuff[0] == 'A' && readbuff[1] == 'R' ) 
		{
			sscanf( &readbuff[3], "%d,%d,%d,%d,%d", &index, &left,&top,&right, &bottom );
			if( map_areas_count < MAX_MAP_AREA )
			{
				if( map_colors_count < ( index + 1 ) ) map_colors_count = index + 1;
	    		map_areas[ map_areas_count ][MAP_AREA_COLOR ] = index;
	    		map_areas[ map_areas_count ][MAP_AREA_LEFT  ] = left;
	    		map_areas[ map_areas_count ][MAP_AREA_TOP   ] = top;
	    		map_areas[ map_areas_count ][MAP_AREA_RIGHT ] = right;
	    		map_areas[ map_areas_count ][MAP_AREA_BOTTOM] = bottom;
	    		map_areas[ map_areas_count ][MAP_AREA_TYPE  ] = MAP_AREA_TYPE_NONE;
	    		
	    		map_areas_count++;
			}
			continue;
		}
		
	}

	fclose( fp );
	
	return 0;
}


//--------------------------------------------------------------
//  : GUI ũ  ó ϴ  о ʱȭ Ѵ. 
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_set_dc( dc_t	*dc )
{
	map_dc = dc;	
	return 0;
}

//--------------------------------------------------------------
//  :  ȭ ׸.
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_draw_front( void )
{
	gx_bitblt( map_dc, 0, 0, (dc_t *)map_bmp_front, 0, 0, map_bmp_front->width-1, map_bmp_front->height-1);	
	return 0;
}

//--------------------------------------------------------------
//  : ̺Ʈ ͸ Ѱ  ó Ѵ. 
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_put_ie_event( ie_event_t *event_data )
{
	// 콺 ǥ Ѵ. 
	switch(event_data->type)
	{
	case IE_MOUSE_DOWN	:
	case IE_MOUSE_UP 	:
	case IE_MOUSE_MOVE 	:	map_last_x = event_data->data.mouse.x;
							map_last_y = event_data->data.mouse.y;
							break;	
	}
	
	return 0;
	
}

//--------------------------------------------------------------
//  :  ε Ѵ.
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_get_area( void )
{
    color_t  	color;
	int			lp;
	
    gx_get_pixel( map_bmp_mask, map_last_x, map_last_y, &color );

    for( lp = 0; lp < 4; lp++ )
    {
		if( map_colors[lp].red		!= color.red 	) continue;
		if( map_colors[lp].green	!= color.green 	) continue;
		if( map_colors[lp].blue		!= color.blue  	) continue;

		return lp;
    }
    
    return -1;
    
}

//--------------------------------------------------------------
//  :   ׸. 	
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_draw_area_front	( int area_index )
{
	int lp;
	int x1, x2, y1,y2;
	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR ] != area_index ) continue;
		
	    x1 = map_areas[ lp ][MAP_AREA_LEFT  ];
	    y1 = map_areas[ lp ][MAP_AREA_TOP   ];
	    x2 = map_areas[ lp ][MAP_AREA_RIGHT ];
	    y2 = map_areas[ lp ][MAP_AREA_BOTTOM];
	    
	    gx_bitblt( map_dc, x1, y1, (dc_t *)map_bmp_front, x1, y1, x2-x1, y2-y1 );
		
	}
	return 0;
}


//------------------------------------------------------------------------------
/** @brief	  ׸.   
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_draw_area_back	( int area_index )
{
	int lp;
	int x1, x2, y1,y2;
	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR ] != area_index ) continue;
		
	    x1 = map_areas[ lp ][MAP_AREA_LEFT  ];
	    y1 = map_areas[ lp ][MAP_AREA_TOP   ];
	    x2 = map_areas[ lp ][MAP_AREA_RIGHT ];
	    y2 = map_areas[ lp ][MAP_AREA_BOTTOM];
	    
	    gx_bitblt( map_dc, x1, y1, (dc_t *)map_bmp_back, x1, y1, x2-x1, y2-y1 );
	}
	return 0;
}

//------------------------------------------------------------------------------
/** @brief	ũ  ڿ  ư  ǥ Ѵ.    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_mark_button( int area_index )
{
	int lp;
	//int x1, x2, y1,y2;
	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR ] != area_index ) continue;
	    map_areas[lp][MAP_AREA_TYPE] = MAP_AREA_TYPE_BUTTON;
	}
	return 0;
}

//------------------------------------------------------------------------------
/** @brief	ư ٿ  ׸.     
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_draw_button_down( int area_index )
{
	int lp;
	int x1, x2, y1,y2;
	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR  ] != area_index 			) continue;
		if( map_areas[ lp ][MAP_AREA_TYPE ] != MAP_AREA_TYPE_BUTTON 	) continue;
		
	    x1 = map_areas[ lp ][MAP_AREA_LEFT  ];
	    y1 = map_areas[ lp ][MAP_AREA_TOP   ];
	    x2 = map_areas[ lp ][MAP_AREA_RIGHT ];
	    y2 = map_areas[ lp ][MAP_AREA_BOTTOM];
	    
	    gx_bitblt( map_dc, x1, y1, (dc_t *)map_bmp_back, x1, y1, x2-x1, y2-y1 );
	}
	return 0;
}

//------------------------------------------------------------------------------
/** @brief    ư msec    ׸.
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_draw_button_up	( int area_index , int msec_delay )
{
	
	int lp;
	int x1, x2, y1,y2;

	//  ó 	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR ] != area_index ) continue;
		if( map_areas[ lp ][MAP_AREA_TYPE ] != MAP_AREA_TYPE_BUTTON 	) continue;
		usleep( msec_delay );
		break;	
	}
		
	// ǥ ó 	
	for( lp = 0; lp < map_areas_count; lp++ )
	{
		if( map_areas[ lp ][MAP_AREA_COLOR ] != area_index ) continue;
		if( map_areas[ lp ][MAP_AREA_TYPE ] != MAP_AREA_TYPE_BUTTON 	) continue;
		
	    x1 = map_areas[ lp ][MAP_AREA_LEFT  ];
	    y1 = map_areas[ lp ][MAP_AREA_TOP   ];
	    x2 = map_areas[ lp ][MAP_AREA_RIGHT ];
	    y2 = map_areas[ lp ][MAP_AREA_BOTTOM];
	    
	    gx_bitblt( map_dc, x1, y1, (dc_t *)map_bmp_front, x1, y1, x2-x1, y2-y1 );
	}
	return 0;
}


//--------------------------------------------------------------
//  : 콺 ġ ´.
//--------------------------------------------------------------
//------------------------------------------------------------------------------
/** @brief    
    @param    
    @return   
    @remark   
*///----------------------------------------------------------------------------
int ux_gui_screen_map_get_mouse_pos( int *x, int *y )
{
	*x = map_last_x;
	*y = map_last_y;
	
	return 0;
}


