//------------------------------------------------------------------------------
//    : sample_bmp2mask.c
// Ʈ : exlib
//      :
//    : â
//    : 2009 3 7
//    :
//    :
//      :
// ̼ : 
//------------------------------------------------------------------------------
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <gx.h>
#include <gxbmp.h>

static bmp_t   	*bmp 	= NULL;



#define MAX_COLOR_ITEMS             128

static color_t 	map_colors[MAX_COLOR_ITEMS];
static int 		map_colors_count = 0;

static int      color_idx;
static int      area_top;
static int      area_bottom;
static int      area_left;
static int      area_right;

//--------------------------------------------------------------
//  :   ֻ  ǥ ´. 
// Ű : search_start_y : ã ؾ ϴ   
// ȯ : 0   ߰  
//        0  ũ ǥ 
//--------------------------------------------------------------
int search_area_top( int search_start_y )
{
	int 		y;
	int 		x;
	color_t 	color;
	
	for( y = search_start_y; y < bmp->height; y++ )
	{
		for( x = 0; x < bmp->width; x++ )
		{
	    	gx_get_pixel( bmp, x, y, &color );
	    	if( map_colors[ color_idx ].red 	!= color.red 	) continue ;
	    	if( map_colors[ color_idx ].green 	!= color.green 	) continue ;
	    	if( map_colors[ color_idx ].blue 	!= color.blue 	) continue ;

	    	return y;
	    }	
   	}
	
	return -1;
}

//--------------------------------------------------------------
//  :   ϴ  ǥ ´. 
// Ű : search_start_y : ã ؾ ϴ   
// ȯ : 0   ߰  
//        0  ũ ǥ 
//--------------------------------------------------------------
int search_area_bottom( int search_start_y )
{
	int 		y;
	int 		x;
	int 		find_color;
	color_t 	color;
	
	for( y = search_start_y; y < bmp->height; y++ )
	{
		
		find_color = 0;
		for( x = 0; x < bmp->width; x++ )
		{
	    	gx_get_pixel( bmp, x, y, &color );
	    	if( map_colors[ color_idx ].red 	!= color.red 	) continue ;
	    	if( map_colors[ color_idx ].green 	!= color.green 	) continue ;
	    	if( map_colors[ color_idx ].blue 	!= color.blue 	) continue ;

	    	find_color = 1;
	    	break;
	    }
	    if( !find_color ) return y-1;
	    
   	}
	
	return bmp->height-1;
}

//--------------------------------------------------------------
//  :     ǥ ´. 
// Ű : search_start_x : ã ؾ ϴ   
// ȯ : 0   ߰  
//        0  ũ ǥ 
//--------------------------------------------------------------
int search_area_left( int top, int bottom, int search_start_x )
{
	int 		y;
	int 		x;
	color_t 	color;

	for( x = search_start_x; x < bmp->width; x++ )
	{
		for( y = top; y < bottom; y++ )	
		{
	    	gx_get_pixel( bmp, x, y, &color );
	    	if( map_colors[ color_idx ].red 	!= color.red 	) continue ;
	    	if( map_colors[ color_idx ].green 	!= color.green 	) continue ;
	    	if( map_colors[ color_idx ].blue 	!= color.blue 	) continue ;

	    	return x;
		}
	}
	
	return -1;
}

//--------------------------------------------------------------
//  :   ֿ  ǥ ´. 
// Ű : search_start_x : ã ؾ ϴ   
// ȯ : 0   ߰  
//        0  ũ ǥ 
//--------------------------------------------------------------
int search_area_right( int top, int bottom, int search_start_x )
{
	int 		y;
	int 		x;
	int 		find_color;
	color_t 	color;

	for( x = search_start_x; x < bmp->width; x++ )
	{
		find_color = 0;
		for( y = top; y < bottom; y++ )	
		{
	    	gx_get_pixel( bmp, x, y, &color );
	    	if( map_colors[ color_idx ].red 	!= color.red 	) continue ;
	    	if( map_colors[ color_idx ].green 	!= color.green 	) continue ;
	    	if( map_colors[ color_idx ].blue 	!= color.blue 	) continue ;

	    	find_color = 1;
	    	break;
		}
		if( !find_color ) return x-1;
	}
	
	return bmp->width-1;
}


//--------------------------------------------------------------
//  :  α׷ 
//--------------------------------------------------------------
int main( int argc, char **argv )
{
	int 		x, y,c_lp;
	color_t 	color;
	int         same_color;

	
	if( argc != 2 ) 
	{
		printf( "usage : yyc_m2d bmp_filename\n" ); 
		exit(0);
	}
	
	
	bmp = gx_bmp_open( argv[1] ); // Bmp ü  Ŀ,  
	if( bmp == NULL )
	{
		printf( "file open fail!!! [%s]\n", argv[1] );	
		exit(0);
	}
	
	printf( "RM mask bmp file : %s\n", argv[1] ); 
	printf( "RM width  = %d\n"	,  bmp->width );
	printf( "RM height = %d\n"	,  bmp->height );
	
	
	//  Ѽ ã´. 
	//  128  ũ Ϸ  ʰ  .
	
	for( y = 0; y < bmp->height; y++ )
	{
		for( x = 0; x < bmp->width; x++ )
		{
		    gx_get_pixel( bmp, x, y, &color );
		    
		    if( ( (int) color.red + (int) color.green +  (int) color.blue ) == 0 ) continue ;
		    
		    same_color = 0;
		    for( c_lp = 0; c_lp < map_colors_count; c_lp++ )
		    {

		    	if( map_colors[c_lp].red 	!= color.red 	) continue ;
		    	if( map_colors[c_lp].green 	!= color.green 	) continue ;
		    	if( map_colors[c_lp].blue 	!= color.blue 	) continue ;
		    		
		    	same_color = 1;	
		    }
		    if( !same_color )
		    {
		    	if( map_colors_count >= MAX_COLOR_ITEMS ) 
		    	{
		    		printf( "RM OVER color count > %d\n", MAX_COLOR_ITEMS );
		    		exit( 0 );
		    	}
		    		
		    	map_colors[map_colors_count].red 	= color.red;
		    	map_colors[map_colors_count].green 	= color.green;
		    	map_colors[map_colors_count].blue 	= color.blue;
		    	map_colors_count++;
			}	
		}
	}
	
	printf( "RM color count = %d\n"	,  map_colors_count );
	printf( "RM  id  red green blue\n" );

    for( c_lp = 0; c_lp < map_colors_count; c_lp++ )
    {
    	printf	( "CM %03d, %03d, %03d, %03d\n"	,  	c_lp, 
		    								map_colors[c_lp].red,
		    								map_colors[c_lp].green,
		    								map_colors[c_lp].blue
		    	);
    }

    //   ϴ  簢  ߰ Ѵ.
    for( c_lp = 0; c_lp < map_colors_count; c_lp++ )
    {
    	color_idx 	= c_lp;
    	area_bottom = -1;
    	while(1)
    	{
    		area_top 	= search_area_top	( area_bottom + 1 ); if( area_top < 0 ) break;
    		area_bottom = search_area_bottom( area_top );
    		
    		area_right = -1;
    		while(1)
    		{
    			area_left 	= search_area_left	( area_top, area_bottom, area_right+1 	); if( area_left < 0 ) break;
    			area_right	= search_area_right	( area_top, area_bottom, area_left 		);
    			printf	( "AR %03d, %03d, %03d, %03d, %03d\n"	,  
    										color_idx, 
		    								area_left,
		    								area_top,
		    								area_right,
		    								area_bottom					
		    	);
    		}	
    		
    	}
	}
	
	printf( "ED\n" );

	return 0;
}


