//------------------------------------------------------------------------------
//    : ix_read_event_data_low.c
// Ʈ : fwp
//      : ix_read_event_data_low() Լ test 
//    : 
//    : 2009 3 9
//    :
//    :
//      :
// ̼ : BSD
//------------------------------------------------------------------------------
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>                     // O_RDWR , O_NOCTTY   
#include <linux/input.h>

#include <ix.h>
typedef struct {

	char 	*name;
	int	code;

}key_info_t;


static key_info_t	key_info[]={
			{ "KEY_RESERVED   ", 	KEY_RESERVED      },
			{ "KEY_ESC        ", 	KEY_ESC            },
			{ "KEY_1          ", 	KEY_1              },
			{ "KEY_2          ", 	KEY_2              },
			{ "KEY_3          ", 	KEY_3              },
			{ "KEY_4          ", 	KEY_4              },
			{ "KEY_5          ", 	KEY_5              },
			{ "KEY_6          ", 	KEY_6              },
			{ "KEY_7          ", 	KEY_7              },
			{ "KEY_8          ", 	KEY_8              },
			{ "KEY_9          ", 	KEY_9              },
			{ "KEY_0          ", 	KEY_0              },
			{ "KEY_MINUS      ", 	KEY_MINUS         },
			{ "KEY_EQUAL      ", 	KEY_EQUAL         },
			{ "KEY_BACKSPACE  ", 	KEY_BACKSPACE     },
			{ "KEY_TAB        ", 	KEY_TAB            },
			{ "KEY_Q          ", 	KEY_Q              },
			{ "KEY_W          ", 	KEY_W              },
			{ "KEY_E          ", 	KEY_E              },
			{ "KEY_R          ", 	KEY_R              },
			{ "KEY_T          ", 	KEY_T              },
			{ "KEY_Y          ", 	KEY_Y              },
			{ "KEY_U          ", 	KEY_U              },
			{ "KEY_I          ", 	KEY_I               },
			{ "KEY_O          ", 	KEY_O              },
			{ "KEY_P          ", 	KEY_P               },
			{ "KEY_LEFTBRACE  ", 	KEY_LEFTBRACE    },
			{ "KEY_RIGHTBRACE ", 	KEY_RIGHTBRACE   },
			{ "KEY_ENTER      ", 	KEY_ENTER         },
			{ "KEY_LEFTCTRL   ", 	KEY_LEFTCTRL      },
			{ "KEY_A          ", 	KEY_A              },
			{ "KEY_S          ", 	KEY_S              },
			{ "KEY_D          ", 	KEY_D              },
			{ "KEY_F          ", 	KEY_F               },
			{ "KEY_G          ", 	KEY_G              },
			{ "KEY_H          ", 	KEY_H              },
			{ "KEY_J          ", 	KEY_J               },
			{ "KEY_K          ", 	KEY_K              },
			{ "KEY_L          ", 	KEY_L              },
			{ "KEY_SEMICOLON  ", 	KEY_SEMICOLON    },
			{ "KEY_APOSTROPHE ", 	KEY_APOSTROPHE   },
			{ "KEY_GRAVE      ", 	KEY_GRAVE         },
			{ "KEY_LEFTSHIFT  ", 	KEY_LEFTSHIFT     },
			{ "KEY_BACKSLASH  ", 	KEY_BACKSLASH   },
			{ "KEY_Z          ", 	KEY_Z              },
			{ "KEY_X          ", 	KEY_X              },
			{ "KEY_C          ", 	KEY_C              },
			{ "KEY_V          ", 	KEY_V              },
			{ "KEY_B          ", 	KEY_B              },
			{ "KEY_N          ", 	KEY_N             },
			{ "KEY_M          ", 	KEY_M             },
			{ "KEY_COMMA      ", 	KEY_COMMA       },
			{ "KEY_DOT        ", 	KEY_DOT           },
			{ "KEY_SLASH      ", 	KEY_SLASH         },
			{ "KEY_RIGHTSHIFT ", 	KEY_RIGHTSHIFT   },
			{ "KEY_KPASTERISK ", 	KEY_KPASTERISK   },
			{ "KEY_LEFTALT    ", 	KEY_LEFTALT       },
			{ "KEY_SPACE      ", 	KEY_SPACE         },
			{ "KEY_CAPSLOCK   ", 	KEY_CAPSLOCK    },
			{ "KEY_F1         ", 	KEY_F1             },
			{ "KEY_F2         ", 	KEY_F2             },
			{ "KEY_F3         ", 	KEY_F3             },
			{ "KEY_F4         ", 	KEY_F4             },
			{ "KEY_F5         ", 	KEY_F5             },
			{ "KEY_F6         ", 	KEY_F6             },
			{ "KEY_F7         ", 	KEY_F7             },
			{ "KEY_F8         ", 	KEY_F8             },
			{ "KEY_F9         ", 	KEY_F9             },
			{ "KEY_F10        ", 	KEY_F10            },
			{ "KEY_NUMLOCK    ", 	KEY_NUMLOCK     },
			{ "KEY_SCROLLLOCK ", 	KEY_SCROLLLOCK  },
			{ "KEY_KP7        ", 	KEY_KP7            },
			{ "KEY_KP8        ", 	KEY_KP8            },
			{ "KEY_KP9        ", 	KEY_KP9            },
			{ "KEY_KPMINUS    ", 	KEY_KPMINUS      },
			{ "KEY_KP4        ", 	KEY_KP4            },
			{ "KEY_KP5        ", 	KEY_KP5            },
			{ "KEY_KP6        ", 	KEY_KP6            },
			{ "KEY_KPPLUS     ", 	KEY_KPPLUS        },
			{ "KEY_KP1        ", 	KEY_KP1            },
			{ "KEY_KP2        ", 	KEY_KP2            },
			{ "KEY_KP3        ", 	KEY_KP3            },
			{ "KEY_KP0        ", 	KEY_KP0            },
			{ "KEY_KPDOT      ", 	KEY_KPDOT          },
			{ NULL		   , 	0		     },

			};

int main( int argc, char **argv )
{
	key_info_t *key_info_ptr = NULL ;
	int fd ;
	int key	=0;
	int key_state=0;

	if(argc < 2)
	{
		printf("===================================\n");
		printf(" ̽ Է ּ !!\n");
		printf("===================================\n");
		system("cat /proc/bus/input/devices");		
		printf("===================================\n");
		printf(">\n");
		printf("#./sample_input_test /dev/input/event1 \n" );
		return 0;
	}

	fd = open(*(argv+1) , O_RDWR | O_NOCTTY );

	if(fd < 0)
	{
		printf("device file open error!\n");
		return -1;
	}

	while(1)
	{
		if(!ix_read_keyboard_low(fd ,&key, &key_state))
		{
			key_info_ptr =(key_info_t *) &key_info;

			while(key_info_ptr->name != NULL)
			{
				if(key == key_info_ptr->code)				break;
				key_info_ptr++;
			}

			if(key_info_ptr->name != NULL)
			{
				printf("[key str]:%s  ,[key]:%d ",key_info_ptr->name ,key);
			}

			switch(key_state)
			{
			case 0	:	printf("UP \n"); 		break;
			case 1	:	printf("DOWN \n"); 	break;
			case 2	:	printf("REPEAT \n"); 	break;
			default	:	printf("UNKONWN \n");	break;
			}
		}
	}

	return 0;
}


