//------------------------------------------------------------------------------
//    : sample_touch_calibration.c
// Ʈ : exlib
//      :
//    : â
//    : 2009 2 28
//    :
//    :
//      :
// ̼ : 
//------------------------------------------------------------------------------
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/kd.h>

#include <gx.h>
#include <ex.h>
#include <ix.h>

#define MAX_TOUCH             4
#define LEAF_WIDTH           40


ix_cal_touch_info_t  touch_info[MAX_TOUCH] = 
{
	// tx,     ty,    sx,   sy
	{ 	0, 		0, 		80, 	80	},
	{ 	0, 		0, 		560, 	80	},
	{ 	0, 		0, 		80, 	400	},
	{ 	0, 		0, 		560, 	400	},
};
   
static dc_t     *dc_screen = NULL;

static char 	toutch_adjust_filename[128] = "/etc/fwp_tc.cfg";
   
//--------------------------------------------------------------
//  : ̺귯 ʱȭ 
//--------------------------------------------------------------
int lib_init( void )
{
   	if ( gx_init( "/dev/fb")) 							//  ۸ ̿Ͽ gxLib ʱȭ
   	{
   		gx_print_error("\n");                            
		exit(0);
   	}
   	
	if( ex_init( EX_WAIT_TIME_DEFAULT ) )				// ex lib ʱȭ Ѵ.					
	{
		ex_print_error("\n");
		exit(0);
	}

	if( ix_init() )										// ix lib ʱȭѴ.
	{
		ix_print_error("\n");
		exit(0);
	}
	
	return 0;
}

void ix_tty_cursor_off( void )
{
       int fd;

       fd = open("/dev/tty0",O_WRONLY);
       if(fd<0) 
       {
       		printf("No /dev/tty0 device\n");
       		exit(1);
       	}	
       else     
       {
       		ioctl(fd, KDSETMODE, KD_GRAPHICS);
       }		

       close( fd );

}	

//--------------------------------------------------------------
//  :  α׷ 
//--------------------------------------------------------------
int main( int argc, char **argv )
{
	int 	fd;
	color_t red;
	int 	index;
	int 	x, y, press;
	FILE    *fp;
	
	if( argc > 1 ) 
	{
		strcpy( toutch_adjust_filename, argv[1] );
	}		
		
	printf( "toutch info save file -> %s\n",  toutch_adjust_filename );	
	
	// ̺귯  ʱȭ Ѵ. 
	lib_init();		
	
	ix_tty_cursor_off();
	
	// ڰ ǥ ũ  . 
	if(!(dc_screen=gx_get_screen_dc()))					//  ߻ϸ 1 Ѵ.
	{
		gx_print_error("dc get fail\n");
		exit(0);
	}
	
	
	// ġ ̽ ´. 	
	ix_scan_device();
	fd = ix_get_touch_fd( IX_TMP_PATH_DEFAULT );
	if( fd < 0 ) 
	{
		printf( "toutch not found\n" );
		exit(0);
	}	
	
	//  ڰ ׸ ش ġѴ. 
	for( index = 0; index < MAX_TOUCH; index++ )
	{
		gx_clear( dc_screen,gx_color(0,0,0, 255));
		red = gx_color(255,255,0, 255);
		gx_hline( dc_screen , 	touch_info[index].sx-LEAF_WIDTH,
								touch_info[index].sx+LEAF_WIDTH,
								touch_info[index].sy,
								red );
		gx_vline( dc_screen , 	touch_info[index].sx,
								touch_info[index].sy-LEAF_WIDTH,
								touch_info[index].sy+LEAF_WIDTH,
								red );
	
		// ó  ǥ  
		while(1)
		{							
			ix_read_touch_low( fd,  &x, &y, &press );	// touch  о ´.
			if( press ) 
			{
				touch_info[index].tx = x;
				touch_info[index].ty = y;
				printf( "x = %d , y = %d\n", touch_info[index].tx, touch_info[index].ty );
				break;
			}		
		}
		// ġ    				
		while(1)
		{							
			ix_read_touch_low( fd,  &x, &y, &press );	// touch  о ´.
			if( !press ) break;
		}	
	}	
	
	gx_clear( dc_screen,gx_color(0,0,0, 255));
	
	// Ͽ ϰ .
	fp = fopen( toutch_adjust_filename, "w" );
	if( fp != NULL )
	{
		for( index = 0; index < MAX_TOUCH; index++ )
		{
			fprintf( fp, "%d,%d,%d,%d\n", touch_info[index].sx, touch_info[index].sy,touch_info[index].tx, touch_info[index].ty );
		}	
		
		fclose( fp );
	}
	
	return 0;
}

