//------------------------------------------------------------------------------
/** @file    	z_sample_uxgui.c
    @brief   	
    	smallGUI ̿ GUIǰ\n
    	ġũ ̿ ׸ Ʈ  
    @author  	â bmfrog2@gmail.com
	@date 		2009 3 7
	@license 	GPLv2
*///----------------------------------------------------------------------------
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#include <gx.h>
#include <gxbmp.h>
#include <ex.h>
#include <ix.h>

#include <ux_gui.h>

#define MAX_TOUCH             4

static dc_t     *dc_screen = NULL;

static int		old_x = -1;
static int		old_y = -1;


#define AREA_PAD              0					/**< ʱü 		*/
#define AREA_CLEAR_BUTTON     1					/**<  ư 	*/
#define AREA_TRANS_BUTTON     2					/**< ȯ ư 		*/	 
#define AREA_QUIT_BUTTON      3					/**<  ư 	*/	
#define AREA_NONE             -1

//------------------------------------------------------------------------------
/** @brief    ʱü   ó Ѵ. 
    @param    
    @return   
    @remark
*///----------------------------------------------------------------------------
int hand_write_proc( ie_event_t *event_data )
{
	int x, y;

	ux_gui_screen_map_get_mouse_pos( &x, &y );

	dc_screen->pen_color    = gx_color( 255,   0, 255, 255);
	dc_screen->brush_color  = gx_color( 255, 255,   0, 255);
		
	if( old_x == -1 || old_y == -1 ) 
	{
		gx_move_to( dc_screen, x, y );
	}		
	old_x = x;
	old_y = y;
		
	switch(event_data->type)
	{
	case IE_MOUSE_DOWN	:	gx_move_to( dc_screen, x, y ); break;
	case IE_MOUSE_UP 	:	
	case IE_MOUSE_MOVE 	:	gx_line_to( dc_screen, x, y ); break;
	}
	return 0;
}

//------------------------------------------------------------------------------
/** @brief    ʱü   ó Ѵ. 
    @param    
    @return   
    @remark
*///----------------------------------------------------------------------------
int clear_hand_write_area( void )
{
	dc_screen->pen_color    = gx_color( 255,255, 255, 255);
	dc_screen->brush_color  = gx_color( 255,255, 255, 255);
	gx_rectangle( dc_screen, 51, 117, 358, 424 );
	
	return 0;
}


//------------------------------------------------------------------------------
/** @brief   Է ġ ߻ ̺Ʈ IE_EVENT óѴ. 
    @param    
    @return   
    @remark
*///----------------------------------------------------------------------------
static int event_handler(ie_event_t *event_data )
{
	int area_index;

	
	ux_gui_screen_map_put_ie_event( event_data );			// ̺Ʈ ũ  ޴ Ѵ. 
	area_index = ux_gui_screen_map_get_area();				//    ´. 	
	
	if( AREA_NONE == area_index ) 							//  ̸ ƹ ó  ʴ´. 	
	{	
		old_x = -1;	old_y = -1;	
		return 0; 
	}
	
	// 콺 Ŭ Ǿ ư ٿ · ׸. 	
	if( event_data->type == IE_MOUSE_DOWN ) 				
		ux_gui_screen_map_draw_button_down( area_index );
		
    if( area_index == AREA_PAD ) hand_write_proc( event_data ); // ʱü   ó Ѵ. 
	if( event_data->type == IE_MOUSE_DOWN )						// ư ó Ѵ. 
	{
		switch( area_index )
		{
		case AREA_CLEAR_BUTTON	:  clear_hand_write_area(); break;
		case AREA_TRANS_BUTTON	:  break;
		case AREA_QUIT_BUTTON	:  gx_clear( dc_screen,gx_color(0,0,0, 255));
								   exit(0);					
								   break;
		}
	}	

	// 콺 Ŭ Ǿ ư   UP · ٲ۴.
	if( event_data->type == IE_MOUSE_DOWN ) 				
		ux_gui_screen_map_draw_button_up( area_index, 100000 );
		
	return 0;
}

//------------------------------------------------------------------------------
/** @brief	ũ ʱȭ Ѵ.
    @param    
    @return   
    @remark
*///----------------------------------------------------------------------------
int init_screen( void )
{
	if(!(dc_screen=gx_get_screen_dc()))					// ũ  . 
	{
		gx_print_error("dc get fail\n");
		exit(0);
	}

	ux_gui_screen_map_load		( "./screen00_map.txt" );	// ũ  о ó Ѵ. 
	ux_gui_screen_map_set_dc	( dc_screen );				// ũ  ڿ ȭ  ѱ. 
	ux_gui_screen_map_draw_front();							// ũ  ڿ   ׸ ǥ 䱸Ѵ.
	
	ux_gui_screen_map_mark_button( AREA_CLEAR_BUTTON 	);	// ũ  ڿ  ư  ǥ Ѵ. 
	ux_gui_screen_map_mark_button( AREA_TRANS_BUTTON 	);	// ũ  ڿ  ư  ǥ Ѵ. 
	ux_gui_screen_map_mark_button( AREA_QUIT_BUTTON 	);	// ũ  ڿ  ư  ǥ Ѵ. 

}

//--------------------------------------------------------------
//  :  α׷ 
//--------------------------------------------------------------
int main( int argc, char **argv )
{

	ux_gui_lib_init( 1 );
	init_screen();						// ȭ  ڸ ʱȭ Ѵ. 

	ix_add_event( event_handler );		// ġ ̺Ʈ ޾Ƽ ó Լ Ѵ.

	// ̺Ʈ  . 
	while( 1 )
	{
		if( ex_loop() )
		{
			 ex_print_error("\n");
			 exit(0);
		}
	}
	
	return 0;
}

